import {
  select,
  json,
  geoPath,
  geoMercator,
  zoom,
  zoomIdentity
} from 'd3';
import { feature } from 'topojson';

const width = 960;
const height = 500;

const svg = select('svg')
	.attr('width', width)
	.attr('height', height);

const g = svg.append('g');

g.call(
  zoom()
  	.scaleExtent([0.9, 12])
  	.translateExtent([[-150, -150],[width + 150, height + 150]])
    .extent([[0,0],[width, height]])
  	.on('zoom', event => {
      g.attr('transform', event.transform)
      console.log(event);
    })
);


//read json from gist github link
json('https://gist.githubusercontent.com/ShishiraRudrabhatla/f84a6ab80df59f484cc14652a59c791a/raw/b73c93fa74371655e638f61955e2f967e5b30f66/ice8-singapore.json').then(data => {
  
  console.log(data);
	const projection = geoMercator().fitExtent([[0,0], [960,500]], data);
	const pathGenerator = geoPath().projection(projection);
  
  g.selectAll('path')
    .data(data.features)
    .enter().append('path')
      .attr('class', 'country')
      .attr('d', d => pathGenerator(d))
  		.on('click', d => { console.log(d); })
    .append('title')
      .text(d => d.properties.PLN_AREA_N);
  
});

const clicked = d => {
  zoom()
  	.scaleExtent([0.9, 12])
  	.translateExtent([[-150, -150],[width + 150, height + 150]])
    .extent([[0,0],[width, height]])
  	.on('zoom', () => { g.attr('transform', event.transform) })
}
  